const BATT_MIN 80
const BATT_MAX 104
if init < 2
 if init = 0
  startupTime = gettime()
	init = 1
 end
 drawclear()
 drawtext( 10, 16, "INAV Bas Telemetry")
 drawtext( 39, 24, "ver 1.0")
 if gettime() - startupTime > 149
  init = 2
	battMin = 126
 end
 stop
else
 goto main
end

normalize:
if angle > 360 then angle -= 360
if angle <   0 then angle += 360
return


sin100:
neg = 0
	gosub normalize
	if angle > 180
		neg = 1
		angle -= 180
	end
	if angle > 90 then angle = 180 - angle
	scresult = 3283 - angle * angle / 20
	scresult = 3283 - scresult * angle * angle / 19697
	scresult = scresult * angle / 1880
	if neg then scresult = -scresult
return

cos100:
	angle += 90
	gosub normalize
	gosub sin100
return


drawDirection
angle = ddheading
gosub sin100
ddx1 = scresult * ddradius / 100 + ddx

angle = ddheading
gosub cos100
ddy1 = ddy - scresult * ddradius / 100

angle = ddheading + ddwidth
gosub sin100
ddx2 = ddx - scresult * ddradius / 100

angle = ddheading + ddwidth
gosub cos100
ddy2 = ddy + scresult * ddradius / 100

angle = ddheading - ddwidth
gosub sin100
ddx3 = ddx - scresult * ddradius / 100

angle = ddheading - ddwidth
gosub cos100
ddy3 = ddy + scresult * ddradius / 100

drawline( ddx1, ddy1, ddx2, ddy2, 1)
drawline( ddx1, ddy1, ddx3, ddy3, 1)

return
	 


rem hbar:
rem drawrectangle( rx, ry, rw, rh )
rem if percent
rem  rw -= 2
rem  rw = rw * percent / 100
rem  rw += rx
rem  rx += 1
rem  ry += 1
rem  rh -= 2
rem  while rh > 0
rem   drawline( rx, ry, rw, ry )
rem   ry += 1
rem 	rh -= 1 
rem  end
rem end
rem return


main:

drawclear()

drawrectangle( 0, 0, 127, 8, 100 )

rem let value = getvalue( "RxV" )
let value = getvalue( "A1=" )
drawnumber( 121, 0, value, PREC1 | INVERS )
drawtext(122, 0, "V", INVERS )

let value = getvalue( "Amps" )
drawtext(0, 32, "Curr   A")
attr = PREC1
if value > 99
 value /= 10
 attr = 0
end
drawnumber( 41, 32, value )

let value = getvalue( "Tim1" )
drawtimer( 60, 0, value, INVERS )

drawline( 80, 1, 99, 1 )
drawline( 80, 2, 100, 2 )
drawline( 80, 3, 100, 3 )
drawline( 80, 4, 100, 4 )
drawline( 80, 5, 100, 5 )
drawline( 80, 6, 99, 6 )
let value = getvalue( "Batt" )
value -= BATT_MIN
if value < 0 then value = 0
range = BATT_MAX - BATT_MIN
value *= 9
value /= range
x = 82
while value > 0
 drawline( x, 2, x, 5 )
 x += 2
 value -= 1
end

let percent = getvalue( "FUEL" )
drawtext(0, 40, "Fuel   %")
drawnumber( 41, 40, percent )
drawrectangle( 56, 41, 72, 7, percent )

rem let value = getvalue( "FasV" )
let value = getvalue( "A2=" )
if value < battMin then battMin = value
drawtext(0, 48, "Batt    V")
drawnumber( 47, 48, value, PREC1 )
percent = value - 90
if percent < 0 then percent = 0
percent *= 100
percent /= 36
drawrectangle( 56, 49, 72, 7, percent )
percent = battMin - 90
if percent < 0 then percent = 0
percent *= 70
percent /= 36
percent += 56
if percent > 56 then drawline( percent, 50, percent, 54)

gps_sat = getvalue("T1=")
drawnumber( 127, 8, gps_sat )

rem satellite image

tmp = 115
if gps_sat < 10 then tmp += 6
drawpoint(tmp - 7, 9)
drawline(tmp - 7, 10, tmp - 6, 10)
drawline(tmp - 7, 11, tmp - 5, 11)
drawline(tmp - 6, 12, tmp - 4, 12)
drawline(tmp - 5, 13, tmp - 3, 13)
drawline(tmp - 8, 14, tmp - 6, 14)
drawpoint(tmp - 7, 13)
drawpoint(tmp - 4, 10)

gps_fix = getvalue("T2=")
drawtext(80, 16, "Fix:")
if gps_fix = 3
 drawtext(104, 16, "DGPS")
elseif gps_fix = 1
 drawtext(116, 16, "2D")
elseif gps_fix = 2
 drawtext(116, 16, "3D")
else
 drawtext(116, 16, "No")
end

let percent = getvalue( "RSSI" )
drawtext(0, 56, "RSSI   db")
drawnumber( 41, 56, percent )
drawrectangle( 56, 57, 72, 77, percent )

ddheading = getvalue( "SC5" )
ddwidth = 25
ddradius = 10
ddx = 60
ddy = 20
gosub drawDirection

value = getvalue( "LAT" )
drawnumber( 127, 24, value )
value = getvalue( "LONG" )
drawnumber( 127, 32, value )

if sysflags() & 2
 if Event = EVT_EXIT_BREAK then goto done
 if Event = EVT_BTN_BREAK then goto done
end

stop
done:
finish
